package com.casic.dcms.view.statistics;

import android.content.Context;
import android.view.View;
import android.widget.RadioGroup;

import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.casic.dcms.R;
import com.casic.dcms.databinding.ActivityDeptHandleConditionBinding;
import com.casic.dcms.model.DeptHandleConditionBean;
import com.casic.dcms.utils.ChartViewHelper;
import com.casic.dcms.utils.ColorHub;
import com.casic.dcms.utils.DialogHelper;
import com.casic.dcms.utils.LocaleConstant;
import com.casic.dcms.utils.TimeOrDateUtil;
import com.casic.dcms.vm.DataAnalysisViewModel;
import com.casic.dcms.widgets.RangeDateActionSheet;
import com.github.mikephil.charting.data.BarEntry;
import com.gyf.immersionbar.ImmersionBar;
import com.pengxh.androidx.lite.adapter.NormalRecyclerAdapter;
import com.pengxh.androidx.lite.adapter.ViewHolder;
import com.pengxh.androidx.lite.base.AndroidxBaseActivity;
import com.pengxh.androidx.lite.divider.ItemDecoration;
import com.pengxh.androidx.lite.hub.FloatHub;
import com.pengxh.androidx.lite.hub.IntHub;
import com.pengxh.androidx.lite.hub.LongHub;
import com.pengxh.androidx.lite.utils.ImmerseStatusBarManager;
import com.pengxh.androidx.lite.vm.LoadState;

import java.util.ArrayList;
import java.util.List;

/**
 * @author a203
 * @package com.casic.dcms.ui
 * @date 2022/2/15 09:46
 * @email 290677893@qq.com
 */
public class DeptHandleConditionActivity extends AndroidxBaseActivity<ActivityDeptHandleConditionBinding> {

    private static final String TAG = "DeptHandleConditionActivity";
    private final Context context = DeptHandleConditionActivity.this;
    private DataAnalysisViewModel dataAnalysisViewModel;

    @Override
    protected void setupTopBarLayout() {
        ImmerseStatusBarManager.setColor(this, IntHub.convertColor(this, R.color.white));
        ImmersionBar.with(this).statusBarDarkFont(true).init();

        viewBinding.titleBarLayout.titleView.setText(LocaleConstant.ANALYSIS_ITEMS.get(3));
        viewBinding.titleBarLayout.leftBackView.setOnClickListener(v -> finish());
    }

    @Override
    protected void observeRequestState() {
        dataAnalysisViewModel.loadState.observe(this, new Observer<LoadState>() {
            @Override
            public void onChanged(LoadState loadState) {
                if (loadState == LoadState.Loading) {
                    DialogHelper.showLoadingDialog(context, "数据加载中，请稍后");
                } else {
                    DialogHelper.dismissLoadingDialog();
                }
            }
        });
    }

    @Override
    protected void initData() {
        dataAnalysisViewModel = new ViewModelProvider(this).get(DataAnalysisViewModel.class);
        dataAnalysisViewModel.deptHandleConditionModel.observe(this, new Observer<DeptHandleConditionBean>() {
            @Override
            public void onChanged(DeptHandleConditionBean conditionBean) {
                if (conditionBean.getCode() == 200) {
                    int caseCount = 0;
                    List<DeptHandleConditionBean.DataModel> dataModels = conditionBean.getData();
                    List<BarEntry> totalCheckBars = new ArrayList<>();
                    List<BarEntry> checkedBars = new ArrayList<>();
                    List<DeptHandleConditionBean.DataModel> effectiveModels = new ArrayList<>();
                    for (int i = 0; i < dataModels.size(); i++) {
                        DeptHandleConditionBean.DataModel dataModel = dataModels.get(i);
                        if (!dataModel.getDepartName().equals("合计")) {
                            effectiveModels.add(dataModel);

                            caseCount += Integer.parseInt(dataModel.getTotalCheckNum());

                            totalCheckBars.add(new BarEntry(i, Integer.parseInt(dataModel.getTotalCheckNum())));
                            checkedBars.add(new BarEntry(i, Integer.parseInt(dataModel.getCheckedNum())));
                        }
                    }
                    viewBinding.caseCountView.setText("案卷数：" + caseCount);

                    ChartViewHelper.setBarChartData(viewBinding.horizontalBarChart, totalCheckBars, checkedBars);

                    //绑定列表
                    NormalRecyclerAdapter<DeptHandleConditionBean.DataModel> recyclerAdapter = new NormalRecyclerAdapter<DeptHandleConditionBean.DataModel>(R.layout.item_case_resource_lv_l, effectiveModels) {
                        @Override
                        public void convertView(ViewHolder viewHolder, int position, DeptHandleConditionBean.DataModel item) {
                            //设置随机颜色
                            int[] color = ColorHub.generateColor(context);

                            viewHolder.setText(R.id.numberTagView, String.valueOf(position + 1))
                                    .setBackgroundColor(R.id.numberTagView, color[0])
                                    .setTextColor(R.id.numberTagView, color[1])
                                    .setText(R.id.caseSourceView, item.getDepartName())
                                    .setText(R.id.caseNumView, item.getTotalCheckNum());
                        }
                    };
                    viewBinding.deptHandleView.addItemDecoration(new ItemDecoration(FloatHub.dp2px(context, 75), FloatHub.dp2px(context, 15)));
                    viewBinding.deptHandleView.setAdapter(recyclerAdapter);
                }
            }
        });
    }

    @Override
    protected void onResume() {
        super.onResume();
        //默认加载当前时间往前一个月的
        dataAnalysisViewModel.getDeptHandleCondition(TimeOrDateUtil.getOneMonthDate(), LongHub.timestampToDate(System.currentTimeMillis()));
    }

    @Override
    protected void initEvent() {
        viewBinding.selectCalendarButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                new RangeDateActionSheet.Builder().setContext(context).setOnActionSheetListener(new RangeDateActionSheet.OnDateRangeSelectedListener() {
                    @Override
                    public void onDateRangeSelected(String startDate, String endDate) {
                        dataAnalysisViewModel.getDeptHandleCondition(startDate, endDate);
                    }
                }).build().show();
            }
        });

        viewBinding.radioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                if (checkedId == R.id.oneMonthRadioButton) {
                    dataAnalysisViewModel.getDeptHandleCondition(TimeOrDateUtil.getOneMonthDate(), LongHub.timestampToDate(System.currentTimeMillis()));
                } else if (checkedId == R.id.threeMonthRadioButton) {
                    dataAnalysisViewModel.getDeptHandleCondition(TimeOrDateUtil.getThreeMonthDate(), LongHub.timestampToDate(System.currentTimeMillis()));
                } else {
                    dataAnalysisViewModel.getDeptHandleCondition(TimeOrDateUtil.getSixMonthDate(), LongHub.timestampToDate(System.currentTimeMillis()));
                }
            }
        });
    }
}
